note
	description : "mysql_demo application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		local
			l_client: MYSQL_CLIENT
			l_result: MYSQL_RESULT
			l_stmt: MYSQL_PREPARED_STATEMENT
			i: INTEGER
			l_data: STRING

		do
				-- Make sure you have the Library database in MySQL server.
				-- Change the password "xxx" according to your password.
			create l_client.make_with_database ("localhost", "root", "minhngoc", "library", 3306)
			l_client.connect

				-- Select books.
				-- Use MYSQL_RESULT
			io.put_string ("-- All books ----------------------------------%N")
			l_client.execute_query ("SELECT * FROM Books")
			l_result := l_client.last_result
			from
				l_result.start
			until
				l_result.after
			loop
				from
					i := 1

				until
					i > l_result.column_count
				loop
					l_data := l_result.at (i)
					if l_data = Void then
						io.put_string ("NULL")
					else
						io.put_string (l_data)
					end
					io.put_character ('%T')
					i := i + 1
				end
				io.put_character ('%N')
				l_result.forth
			end

				-- Select books that are published after 1990
				-- Use prepared statement.
			io.put_string ("-- Books published after 1990 -----------------%N")
			l_client.prepare_statement ("SELECT * FROM Books where year > ?")
			l_stmt := l_client.last_prepared_statement
			l_stmt.set_integer (1, 1990)
			l_stmt.execute

			from
				l_stmt.start
			until
				l_stmt.after
			loop
				from
					i := 1

				until
					i > l_stmt.column_count
				loop
					l_data := l_stmt.at (i)
					if l_data = Void then
						io.put_string ("NULL")
					else
						io.put_string (l_data)
					end
					io.put_character ('%T')
					i := i + 1
				end
				io.put_character ('%N')

				l_stmt.forth
			end

			l_client.close
		end

end
